<template>
  <div>
    <h2 id="page-heading" data-cy="TratamientoHeading">
      <span v-text="$t('gatewayApp.pacientesTratamiento.home.title')" id="tratamiento-heading">Tratamientos</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesTratamiento.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'TratamientoCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-tratamiento"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesTratamiento.home.createLabel')"> Create a new Tratamiento </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && tratamientos && tratamientos.length === 0">
      <span v-text="$t('gatewayApp.pacientesTratamiento.home.notFound')">No tratamientos found</span>
    </div>
    <div class="table-responsive" v-if="tratamientos && tratamientos.length > 0">
      <table class="table table-striped" aria-describedby="tratamientos">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('descripcionTratamiento')">
              <span v-text="$t('gatewayApp.pacientesTratamiento.descripcionTratamiento')">Descripcion Tratamiento</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'descripcionTratamiento'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaInicio')">
              <span v-text="$t('gatewayApp.pacientesTratamiento.fechaInicio')">Fecha Inicio</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaInicio'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaFin')">
              <span v-text="$t('gatewayApp.pacientesTratamiento.fechaFin')">Fecha Fin</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaFin'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="tratamiento in tratamientos" :key="tratamiento.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'TratamientoView', params: { tratamientoId: tratamiento.id } }">{{ tratamiento.id }}</router-link>
            </td>
            <td>{{ tratamiento.descripcionTratamiento }}</td>
            <td>{{ tratamiento.fechaInicio ? $d(Date.parse(tratamiento.fechaInicio), 'short') : '' }}</td>
            <td>{{ tratamiento.fechaFin ? $d(Date.parse(tratamiento.fechaFin), 'short') : '' }}</td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'TratamientoView', params: { tratamientoId: tratamiento.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'TratamientoEdit', params: { tratamientoId: tratamiento.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(tratamiento)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.pacientesTratamiento.delete.question"
          data-cy="tratamientoDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-tratamiento-heading" v-text="$t('gatewayApp.pacientesTratamiento.delete.question', { id: removeId })">
          Are you sure you want to delete this Tratamiento?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-tratamiento"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeTratamiento()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./tratamiento.component.ts"></script>
